#include "Expr.h"
#include "smart_ptr.h"

#include <iostream>
#include <string_view>
#include <vector>
#include <utility>

using namespace std;

template <typename T>
void PrintVector(string_view label, vector<T>& v) {
  cout << label;
  for (auto & x : v) {
    cout << x << " ";
  }
  cout << endl;
}

int main(int argc, char *argv[]) {
  unique_ptr<int> u = std::make_unique<int>(3);
  // unique_ptr v = u;
  int * p = u.get();
  *p = 4;
  cout << *p << ' ' << *u << endl;
  
  // vector<int> v{1, 2, 3};

  // PrintVector("v: ", v);

  // vector u = move(v);
  
  // PrintVector("u: ", u);
  // PrintVector("v: ", v);

  // int * p = new int(3);

  // auto f = [&p]() { return p; };

  // int * q = new int(4);
  // q = f();
  // f() = q;
  // *f() = 5;

  // delete p;
  
  Number three{3};
  Number four{4};
  Add a(three, four);
  cout << a.toString() << endl;
  Mul b(three, four);
  cout << b.toString() << endl;

  Add c(b, a);
  cout << c << endl;
  cout << c.eval() << endl;
  cout << c.left() << endl;
  cout << c.left().eval() << endl;

  cout << "\nour smart pointer\n";

  UniquePtr<int> u1{new int(4)};
  UniquePtr<int> u2 =
    static_cast<UniquePtr<int>&&>(u1);
  // cout << "*u1: " << *u1 << endl;
  *u2 = 5;
  // cout << "*u1: " << *u1 << endl;
  cout << "*u2: " << *u2 << endl;

  int x = 5;
  int y = move(x);
  cout << x << ' ' << y << endl;
  
  return 0;
}
