#include <iostream>

using namespace std;

struct Node {
  string value;
  Node * next;

  Node(string value) : value(value), next(nullptr) {}
  Node(string value, Node * next) : value(value), next(next) {}
};

class List {
  Node * head = nullptr;
  Node * tail = nullptr;
  
public:
  void push_back(string n) {
    if (! head) {
      head = new Node(n);
      tail = head;
    } else {
      tail->next = new Node(n);
      tail = tail->next;
    }
  }

  void push_front(string n) {
    if (! head) {
      head = new Node(n);
      tail = head;
    } else {
      head = new Node(n, head);
    }
  }

  Node * find(string n) {
    Node * current = head;
    while (current) {
      if (current->value == n) {
        return current;
      }
      current = current->next;
    }
    return nullptr;
  }

  void print() const {
    const Node * current = head;
    while (current) {
      cout << current->value << " ";
      current = current->next;
    }
    cout << endl;
  }

  ~List() {
    while (head) {
      auto next = head->next;
      delete head;
      head = next;
    }
  }
};

Node * f() {
  List l;
  l.push_back("1");
  l.push_back("2");
  l.push_back("3");
  l.push_front("a");
  l.push_front("b");

  auto n = l.find("2");
  if (n) {
    n->value = "foo";
  }
  l.print();

  return n;
}

int main(int argc, char * argv[]) {
  Node * not_ok = f();
  //cout << not_ok->value << endl;

  for (int i = 0; i < 30; ++i) {
    List l;
    // 128 MB
    l.push_back(string(1 << 27, 'a'));
    cout << i << endl;
  }
  
  return 0;
}
